<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingjoomlaestateagency extends JPlugin
{
	function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->name = 'jea';
		if(!isset($this->params))
		{
			$plugin = JPluginHelper::getPlugin('acymailing', $this->name);
			$this->params = new JParameter( $plugin->params );
		}

		//check if the component is installed
		if(!file_exists(JPATH_SITE.DS.'components'.DS.'com_jea'))
		{
			$this->component_installed = false;
		}else{
			$this->component_installed = true;
		}
	}

	function acymailing_getPluginType()
	{
		$app = JFactory::getApplication();
		if(!$this->component_installed)
			return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'Joomla Estate Agency';
		$onePlugin->function = 'acymailing_'.$this->name.'_show';
		$onePlugin->help = 'plugin-'.$this->name;
		return $onePlugin;
	}

	function acymailing_jea_show()
	{
		$config = acymailing_config();

		//we will need some 4.5.1 functions
		if($config->get('version') < '4.5.1'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$app = JFactory::getApplication();

		$lang = JFactory::getLanguage();
		$lang->load('com_jea',JPATH_SITE.DS.'components'.DS.'com_jea');
		$lang->load('com_jea',JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.'.$this->name;

		// don't forget to change the default order value if needed
		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order','a.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir','asc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->filter_type = $app->getUserStateFromRequest( $paramBase.".filter_type", 'filter_type','','int' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','id,DESC','string' );
		$pageInfo->cols = $app->getUserStateFromRequest( $paramBase.".cols", 'cols','1','string' );
		$pageInfo->pictheight = $app->getUserStateFromRequest( $paramBase.".pictheight", 'pictheight','150','string' );
		$pageInfo->pictwidth = $app->getUserStateFromRequest( $paramBase.".pictwidth", 'pictwidth','150','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','1','string' );
		$pageInfo->pictauto = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','1','string' );
		$pageInfo->readmore = $app->getUserStateFromRequest( $paramBase.".readmore", 'readmore','1','string' );
		$pageInfo->readmoreauto = $app->getUserStateFromRequest( $paramBase.".readmoreauto", 'readmoreauto','1','string' );
		$pageInfo->wrap = $app->getUserStateFromRequest( $paramBase.".wrap", 'wrap','0','string' );
		$pageInfo->clickable = $app->getUserStateFromRequest( $paramBase.".clickable", 'clickable','1','string' );
		$pageInfo->clickableauto = $app->getUserStateFromRequest( $paramBase.".clickableauto", 'clickableauto','1','string' );
		$pageInfo->depts = $app->getUserStateFromRequest( $paramBase.".depts", 'depts','0','string' );
		$pageInfo->towns = $app->getUserStateFromRequest( $paramBase.".towns", 'towns','0','string' );
		$pageInfo->areas = $app->getUserStateFromRequest( $paramBase.".areas", 'areas','0','string' );

		$db = JFactory::getDBO();

		//the query's start
		$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, b.value AS deptitle, c.value AS towntitle, d.value AS areatitle FROM #__jea_properties AS a ' .
				'LEFT JOIN #__jea_departments AS b ON a.department_id = b.id ' .
				'LEFT JOIN #__jea_towns AS c ON a.town_id = c.id ' .
				'LEFT JOIN #__jea_areas AS d ON a.area_id = d.id ';

		//search fields...
		$searchFields = array('a.id','a.title','a.address','b.value','c.value','d.value');

		//apply search fields
		if(!empty($pageInfo->search))
		{
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE ".$searchVal;
		}

		//only published content ?
		if($this->params->get('displaycontent','all') == 'onlypub')
		{
			$filters[] = 'a.published = 1';
		}

		//if the user filtered by category
		if(!empty($pageInfo->filter_cat))
			$filters[] = 'a.department_id = '.intval($pageInfo->filter_cat);

		//apply filters
		if(!empty($filters))
		{
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		//apply ordering
		if(!empty($pageInfo->filter->order->value))
		{
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);

		//load results
		$rows = $db->loadObjectList();

		//yellow highlighting on search matches
		if(!empty($pageInfo->search))
		{
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		//pagination
		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		//is this a Smart-Newsletter or a simple one ?
		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass)
			{
				<?php
					//we insert contents in the order the user selected it
				?>
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1)
				{
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			function updateTag()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				<?php
					//add the fields the user wants to be displayed
				?>
				for(var i=0; i < document.adminForm.cbdisplay.length; i++)
				{
					if(document.adminForm.cbdisplay[i].checked)
					{
						 if(tmp == 0)
						 {
							 tmp += 1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplay[i].value;
						 }
					}
				}

				<?php
					//is the title clickable ?
				?>
				for(var i=0; i < document.adminForm.clickable.length; i++)
				{
					 if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == '0')
					 {
						 otherinfo += '| nolink';
					 }
				}

				<?php
					//do we have to wrap the text ? (description for example...)
				?>
				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value))
				{
					otherinfo += "| wrap:"+document.adminForm.wrap.value;
				}

				<?php
					//do we have to add a "read more" button ?
				?>
				for(var i=0; i < document.adminForm.readmore.length; i++)
				{
					 if(document.adminForm.readmore[i].checked && document.adminForm.readmore[i].value == '0')
					 {
						 otherinfo += '| noreadmore';
					 }
				}

				<?php
					//picture management
				?>
				for(var i=0; i < document.adminForm.pict.length; i++)
				{
					if (document.adminForm.pict[i].checked)
					{
					 	if(document.adminForm.pict[i].value != '1')
							otherinfo += '| pict:'+document.adminForm.pict[i].value;

						if(document.adminForm.pict[i].value == 'resized')
						{
							 document.getElementById('pictsize').style.display = '';
							 if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidth.value;
							 if(document.adminForm.pictheight.value) otherinfo += '| maxheight:'+document.adminForm.pictheight.value;
						}else{
							document.getElementById('pictsize').style.display = 'none';
						}
					}
				}

				<?php
					//insert the tags with the right order
				?>
				for(var i in selectedContents)
				{
					if(selectedContents[i] && !isNaN(i))
					{
						tag = tag + '{<?php echo $this->name; ?>:'+selectedContents[i]+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}


			function updateTagAuto()
			{
				var tag = '';
				var otherinfo = '';
				var tmp=0;

				for(var i=0; i < document.adminForm.cbdisplayauto.length; i++)
				{
					if (document.adminForm.cbdisplayauto[i].checked)
					{
						 if(tmp==0)
						 {
							 tmp+=1;
							 otherinfo += "| display:";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }else{
							 otherinfo += ", ";
							 otherinfo += document.adminForm.cbdisplayauto[i].value;
						 }
					}
				}

				for(var i=0; i < document.adminForm.clickableauto.length; i++)
				{
					if (document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == '0')
					{
						 otherinfo += '| nolink';
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value))
				{
					otherinfo += "| wrap:"+document.adminForm.wrapauto.value;
				}

				for(var i=0; i < document.adminForm.readmoreauto.length; i++)
				{
					 if (document.adminForm.readmoreauto[i].checked && document.adminForm.readmoreauto[i].value == '0')
					 {
						 otherinfo += '| noreadmore';
					 }
				}

				tmp=0;
				for(var i=0; i < document.adminForm.autopict.length; i++)
				{
					if (document.adminForm.autopict[i].checked)
					{
						if(document.adminForm.autopict[i].value != '1')
							otherinfo += '| pict:'+document.adminForm.autopict[i].value;

						if(document.adminForm.autopict[i].value == 'resized')
						{
							document.getElementById('pictsizeauto').style.display = '';
							if(document.adminForm.pictwidthauto.value) otherinfo += '| maxwidth:'+document.adminForm.pictwidthauto.value;
							if(document.adminForm.pictheightauto.value) otherinfo += '| maxheight:'+document.adminForm.pictheightauto.value;
						}else{
							document.getElementById('pictsizeauto').style.display = 'none';
						}
					}
				}

				if(document.adminForm.areas.value != 0)
				{
					otherinfo += "| area:"+document.adminForm.areas.value;
				}else{
					if(document.adminForm.towns.value != 0)
					{
						otherinfo += "| town:"+document.adminForm.towns.value;
					}else{
						if(document.adminForm.depts.value != 0)
						{
							otherinfo += "| dept:"+document.adminForm.depts.value;
						}
					}
				}

				<?php
					//on how many columns do we have to display the contents ?
				?>
				if(document.adminForm.cols.value)
				{
					otherinfo += "| cols:"+document.adminForm.cols.value;
				}

				<?php
					//limit the number of content displayed
				?>
				if(document.adminForm.max_article.value)
				{
					otherinfo += "| max:"+document.adminForm.max_article.value;
				}

				<?php
					//with what order will we display the contents
				?>
				if(document.adminForm.contentorder.value)
				{
					otherinfo += "| order:"+document.adminForm.contentorder.value;
				}

				if(window.document.getElementById('jlang')  && window.document.getElementById('jlang').value != '')
				{
					otherinfo += '| lang:'+window.document.getElementById('jlang').value;
				}

				<?php if($type == 'autonews'){

					//minimum number of content for the newsletter to be displayed... yes, a perfect english !
				?>
					if(document.adminForm.min_article.value)
					{
						otherinfo += "| min:"+document.adminForm.min_article.value;
					}

					<?php
						//filter the content : only newly created/modified
					?>
					if(document.adminForm.contentfilter && document.adminForm.contentfilter.value != 0)
					{
						otherinfo += "| filter:"+document.adminForm.contentfilter.value;
					}
				<?php }	?>

				tag = '{auto<?php echo $this->name; ?>:'+otherinfo+'}<br />';

				setTag(tag);
			}
		//-->
		</script>
<?php
		// yes/no for the options
		$choice = array();
		$choice[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$choice[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// picture options
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "1", JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "resized", JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "0", JText::_('JOOMEXT_NO'));

		// here are the possible orderings
		$ordering = array();
		$ordering[] = JHTML::_('select.option', "id,DESC", JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "created,DESC", JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "modified,DESC", JText::_('MODIFIED_DATE'));
		$ordering[] = JHTML::_('select.option', "title,ASC", JText::_('FIELD_TITLE'));
		$ordering[] = JHTML::_('select.option', "rand", JText::_('ACY_RANDOM'));

		// filter options
		$contentfilter = array();
		$contentfilter[] = JHTML::_('select.option', "0", JText::_('ACY_ALL'));
		$contentfilter[] = JHTML::_('select.option', "created", JText::_('ONLY_NEW_CREATED'));
		$contentfilter[] = JHTML::_('select.option', "modified", JText::_('ONLY_NEW_MODIFIED'));

		// options for the Nb. columns dropdown (1 to 10)
		$column = array();
		for($i=1;$i<11;$i++)
		{
			$column[] = JHTML::_('select.option', "$i",$i);
		}

		$fieldsDisplay = array();
		$fieldsDisplay[] = array('title' => 'title', 'label' => 'ACY_TITLE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'image', 'label' => 'ACY_IMAGE', 'checked' => 'yes');
		$fieldsDisplay[] = array('title' => 'description', 'label' => 'ACY_DESCRIPTION', 'checked' => 'yes');
		if(ACYMAILING_J16)
		{
			$fieldsDisplay[] = array('title' => 'ref', 'label' => 'COM_JEA_FIELD_REF_LABEL', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'availdate', 'label' => 'COM_JEA_FIELD_PROPERTY_AVAILABILITY_LABEL', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'price', 'label' => 'COM_JEA_FIELD_PRICE_LABEL', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'charges', 'label' => 'COM_JEA_FIELD_CHARGES_LABEL', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'fees', 'label' => 'COM_JEA_FIELD_FEES_LABEL', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'propcond', 'label' => 'COM_JEA_FIELD_CONDITION_LABEL', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'livspace', 'label' => 'COM_JEA_FIELD_LIVING_SPACE_LABEL', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'landspace', 'label' => 'COM_JEA_FIELD_LAND_SPACE_LABEL', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'rooms', 'label' => 'COM_JEA_FIELD_NUMBER_OF_ROOMS_LABEL', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'bedr', 'label' => 'COM_JEA_FIELD_NUMBER_OF_BEDROOMS_LABEL', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'orien', 'label' => 'COM_JEA_FIELD_ORIENTATION_LABEL', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'floor', 'label' => 'COM_JEA_FIELD_FLOOR_LABEL', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'floorsnb', 'label' => 'COM_JEA_FIELD_FLOORS_NUMBER_LABEL', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'baths', 'label' => 'COM_JEA_FIELD_NUMBER_OF_BATHROOMS_LABEL', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'toils', 'label' => 'COM_JEA_FIELD_NUMBER_OF_TOILETS_LABEL', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'heat', 'label' => 'COM_JEA_FIELD_HEATINGTYPE_LABEL', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'water', 'label' => 'COM_JEA_FIELD_HOTWATERTYPE_LABEL', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'address', 'label' => 'COM_JEA_FIELD_ADDRESS_LABEL', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'amenities', 'label' => 'COM_JEA_AMENITIES', 'checked' => 'yes');
		}else{
			$fieldsDisplay[] = array('title' => 'ref', 'label' => 'REFERENCE', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'availdate', 'label' => 'AVAILABILITY DATE', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'price', 'label' => 'BUDGET', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'charges', 'label' => 'CHARGES', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'fees', 'label' => 'FEES', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'propcond', 'label' => 'GENERAL CONDITION', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'livspace', 'label' => 'LIVING SPACE', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'landspace', 'label' => 'LAND SPACE', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'rooms', 'label' => 'NUMBER OF ROOMS', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'floor', 'label' => 'FLOORS', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'baths', 'label' => 'NUMBER OF BATHROOMS', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'toils', 'label' => 'NUMBER OF TOILETS', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'heat', 'label' => 'HEATING TYPE', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'water', 'label' => 'HOT WATER TYPE', 'checked' => '');
			$fieldsDisplay[] = array('title' => 'address', 'label' => 'ADRESS', 'checked' => 'yes');
			$fieldsDisplay[] = array('title' => 'amenities', 'label' => 'ADVANTAGES', 'checked' => 'yes');
		}

		$db->setQuery('SELECT * FROM #__jea_departments ORDER BY value ASC');
		$allDepts = $db->loadObjectList();
		$depts = array();
		$depts[] = JHTML::_('select.option', "0", JText::_('ACY_ALL'));
		foreach($allDepts as $oneDept)
			$depts[] = JHTML::_('select.option', $oneDept->id, $oneDept->value);
		$db->setQuery('SELECT * FROM #__jea_towns ORDER BY value ASC');
		$allTowns = $db->loadObjectList();
		$towns = array();
		$towns[] = JHTML::_('select.option', "0", JText::_('ACY_ALL'));
		foreach($allTowns as $oneTown)
			$towns[] = JHTML::_('select.option', $oneTown->id, $oneTown->value);
		$db->setQuery('SELECT * FROM #__jea_areas ORDER BY value ASC');
		$allAreas = $db->loadObjectList();
		$areas = array();
		$areas[] = JHTML::_('select.option', "0", JText::_('ACY_ALL'));
		foreach($allAreas as $oneArea)
			$areas[] = JHTML::_('select.option', $oneArea->id, $oneArea->value);

		$tabs = acymailing_get('helper.acytabs');

		echo $tabs->startPane( $this->name.'_tab');

		// start the first tab
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), $this->name.'_listings');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField)
					{
						if($i == 5)
						{
							echo '</tr><tr><td/>';
							$i = 1;
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplay" value="'.$oneField['title'].'" id="'.$oneField['title'].'" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTag();"/><label style="margin-left:5px" for="'.$oneField['title'].'">'.JText::_($oneField['label']).'</label></td>';
						$i++;
					}
					while($i != 5)
					{
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickable' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?></td>

				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmore' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->readmore); ?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php echo JText::_('DISPLAY_PICTURES'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
				<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br />
					<?php echo JText::_('CAPTCHA_WIDTH') ?>
					<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
					x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
					<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
				</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
			</tr>
		</table>
		<table>
			<tr>
				<td nowrap="nowrap" width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_departments($pageInfo->filter_cat); ?>
				</>
			</tr>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th/>
					<th class="title">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title">
						<?php
							if(ACYMAILING_J16)
								echo JHTML::_('grid.sort', JText::_( 'COM_JEA_FIELD_ADDRESS_LABEL'), 'address', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
							else
								echo JHTML::_('grid.sort', JText::_( 'ADRESS'), 'address', $pageInfo->filter->order->dir,$pageInfo->filter->order->value );
						?>
					</th>
					<th class="title titleid">
						<?php
							echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value );
						?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					if(!empty($rows))
					{
						foreach($rows as $row)
						{
				?>
							<tr id="content<?php echo $row->id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->id.",'row$k'"?>);" style="cursor:pointer;">
								<td class="acytdcheckbox"></td>
								<td>
									<?php
										if(!empty($row->title))
										{
											echo $row->title;
										}else{
											echo 'Title not defined';
										}
									?>
								</td>
								<td>
									<?php
										$address = array();
										if(!empty($row->deptitle))
										{
											$address[] = $row->deptitle;
											if(!empty($row->towntitle))
												$address[] = $row->towntitle;
											if(!empty($row->areatitle))
												$address[] = $row->areatitle;
										}
										if(!empty($row->address))
											$address[] = $row->address;
										if(!empty($address))
											echo implode(' - ', $address);
										else
											echo 'Address not defined';
									?>
								</td>
								<td align="center" style="text-align:center" >
									<?php
										echo $row->id;
									?>
								</td>
							</tr>
				<?php
							// this enables to know if we have to set the line background grey or white
							$k = 1-$k;
						}
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
<?php

		echo $tabs->endPanel();

		// start category tab
		if(ACYMAILING_J16)
			echo $tabs->startPanel( JText::_('COM_JEA_FIELD_ADDRESS_LABEL'), $this->name.'_auto');
		else
			echo $tabs->startPanel( JText::_('ADRESS'), $this->name.'_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<?php
					// what should we display ?
				?>
				<td nowrap="nowrap"><?php echo JText::_('DISPLAY');?></td>
				<?php
					$i = 1;
					foreach($fieldsDisplay as $oneField)
					{
						if($i%5 == 0)
						{
							echo '</tr><tr><td/>';
							$i++;
						}
						if($i == 4 && ACYMAILING_J16)
						{
							$jflanguages = acymailing_get('type.jflanguages');
							$jflanguages->onclick = 'onchange="updateTagAuto();"';
							$jflanguages->jid = 'jlang';
							$language = $jflanguages->displayJLanguages('jlang');
							if(!empty($language))
							{
								echo '<td>'.$language.'</td></tr><tr><td/>';
								$i += 2;
							}
						}
						echo '<td nowrap="nowrap"><input type="checkbox" name="cbdisplayauto" value="'.$oneField['title'].'" id="'.$oneField['title'].'auto" '.(($oneField['checked'] == 'yes') ? 'checked' : '').' onclick="updateTagAuto();"/><label style="margin-left:5px" for="'.$oneField['title'].'auto">'.JText::_($oneField['label']).'</label></td>';
						$i++;
					}
					while($i%5 != 0)
					{
						echo '<td/>';
						$i++;
					}
				?>
			</tr>
			<tr>
				<td nowrap="nowrap"><?php echo JText::_('CLICKABLE_TITLE'); ?></td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $choice, 'clickableauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?></td>
				<td nowrap="nowrap"><?php echo JText::_('JOOMEXT_READ_MORE'); ?></td>
				<td nowrap="nowrap"><?php echo JHTML::_('acyselect.radiolist', $choice, 'readmoreauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->readmoreauto); ?>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top">
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td nowrap="nowrap" colspan="2"><?php echo JHTML::_('acyselect.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
					<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br />
						<?php echo JText::_('CAPTCHA_WIDTH') ?>
						<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;" />
						x <?php echo JText::_('CAPTCHA_HEIGHT') ?>
						<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;" />
					</span>
				</td>
				<td nowrap="nowrap" colspan="2" valign="top"><?php echo JText::sprintf('TRUNCATE_AFTER','<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_(ACYMAILING_J16 ? 'COM_JEA_FIELD_DEPARTMENT_LABEL' : 'DEPARTMENT'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <?php echo JHTML::_('select.genericlist', $depts, 'depts' , 'size="1" onchange="updateTagAuto();" style="width:150px;"', 'value', 'text', $pageInfo->depts); ?>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_(ACYMAILING_J16 ? 'COM_JEA_FIELD_TOWN_LABEL' : 'TOWN'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $towns, 'towns' , 'size="1" onchange="updateTagAuto();" style="width:150px;"', 'value', 'text', $pageInfo->towns); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap">
					<?php echo JText::_(ACYMAILING_J16 ? 'COM_JEA_FIELD_AREA_LABEL' : 'AREA'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <?php echo JHTML::_('select.genericlist', $areas, 'areas' , 'size="1" onchange="updateTagAuto();" style="width:150px;"', 'value', 'text', $pageInfo->areas); ?>
				</td>
				<td>
					<?php echo JText::_('FIELD_COLUMNS'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $column, 'cols' , 'size="1" onchange="updateTagAuto();" style="width:150px;"', 'value', 'text', $pageInfo->cols); ?>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap" nowrap="nowrap">
					<?php echo JText::_('MAX_ARTICLE'); ?>
				</td>
				<td nowrap="nowrap" colspan="2">
					 <input type="text" name="max_article" style="width:50px" value="20" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('ACY_ORDER'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateTagAuto();" style="width:150px;"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td nowrap="nowrap">
					<?php 	echo JText::_('MIN_ARTICLE'); ?>
				</td nowrap="nowrap">
				<td nowrap="nowrap" colspan="2">
					<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td nowrap="nowrap">
					<?php echo JText::_('JOOMEXT_FILTER'); ?>
				</td>
				<td nowrap="nowrap">
					 <?php echo JHTML::_('select.genericlist', $contentfilter, 'contentfilter' , 'size="1" onchange="updateTagAuto();" style="width:150px;"', 'value', 'text', $pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	 }

	function _departments($filter_cat)
	{
		//select all cats
		$db = JFactory::getDBO();
		$db->setQuery('SELECT * FROM #__jea_departments ORDER BY ordering ASC');
		$mosetCats = $db->loadObjectList();

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		if(!empty($mosetCats))
			foreach($mosetCats as $oneCat)
				$this->catvalues[] = JHTML::_('select.option', $oneCat->id, $oneCat->value);

		return JHTML::_('select.genericlist',$this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', intval($filter_cat));
	}

	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, $this->name);
		if(empty($tags)) return;

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		//Set the read more text or image
		$this->readmore = empty($email->template->readmore) ? JText::_('JOOMEXT_READ_MORE') : '<img src="'.ACYMAILING_LIVE.$email->template->readmore.'" alt="'.JText::_('JOOMEXT_READ_MORE',true).'" />';

		$lang = JFactory::getLanguage();
		$lang->load('com_jea',JPATH_SITE.DS.'components'.DS.'com_jea');
		$lang->load('com_jea',JPATH_SITE);

		if(ACYMAILING_J16)
		{
			if(file_exists(JPATH_SITE.DS.'components'.DS.'com_jea'.DS.'helpers'.DS.'html'.DS.'utility.php'))
				include_once(JPATH_SITE.DS.'components'.DS.'com_jea'.DS.'helpers'.DS.'html'.DS.'utility.php');
		}else{
			if(file_exists(JPATH_SITE.DS.'components'.DS.'com_jea'.DS.'view.php'))
				include_once(JPATH_SITE.DS.'components'.DS.'com_jea'.DS.'view.php');
			$this->jeaParams = JComponentHelper::getParams('com_jea');
		}

		$db = JFactory::getDBO();
		if(ACYMAILING_J16)
			$db->setQuery('SELECT * FROM #__jea_amenities');
		else
			$db->setQuery('SELECT * FROM #__jea_advantages');
		$amenities = $db->loadObjectList();
		$this->amenities = array();
		if(!empty($amenities))
			foreach($amenities as $oneAmenity)
				$this->amenities[$oneAmenity->id] = $oneAmenity->value;

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params)
		{
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content,true);
			$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	 }

	 function _replaceContent(&$tag)
	 {
		$acypluginsHelper = acymailing_get('helper.acyplugins');

	 	// extract the fields selected
		if(!empty($tag->display))
		{
			$tag->display = explode(',',$tag->display);

			foreach($tag->display as $i => $oneDisplay)
			{
				$oneDisplay = trim($oneDisplay);
				$tag->$oneDisplay = true;
			}
			unset($tag->display);
		}

		// load content

		$db = JFactory::getDBO();
		$query = 'SELECT a.*, b.value AS deptitle, c.value AS towntitle, d.value AS areatitle, e.value AS conditiontitle, f.value AS heattitle, g.value AS watertitle FROM #__jea_properties AS a ' .
				'LEFT JOIN #__jea_departments AS b ON a.department_id = b.id ' .
				'LEFT JOIN #__jea_towns AS c ON a.town_id = c.id ' .
				'LEFT JOIN #__jea_areas AS d ON a.area_id = d.id ' .
				'LEFT JOIN #__jea_conditions AS e ON a.condition_id = e.id ' .
				'LEFT JOIN #__jea_heatingtypes AS f ON a.heating_type = f.id ' .
				'LEFT JOIN #__jea_hotwatertypes AS g ON a.hot_water_type = g.id ' .
				'WHERE a.id = '.intval($tag->id).' LIMIT 1';
		$db->setQuery($query);
		$content = $db->loadObject();

		//In case of we could not load the article for any reason...
		if(empty($content)){
			$app = JFactory::getApplication();
			if($app->isAdmin()) $app->enqueueMessage('The content "'.$tag->id.'" could not be loaded','notice');
			return '';
		}

		$varFields = array();
		foreach($content as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		// create the link for the title and the read more button
		$link = ACYMAILING_LIVE.'index.php?option=com_jea&view=propert'.(ACYMAILING_J16 ? 'y' : 'ies').'&id='.$tag->id;
		if(!empty($tag->itemid)) $link .= '&Itemid='.$tag->itemid;
		$varFields['{link}'] = $link;

		$result = '<div class="acymailing_content"><table cellspacing="0" cellpadding="0" border="0" width="100%">';

		// display the title
		if(!empty($tag->title) && !empty($content->title))
		{
			$result .= '<tr><td colspan="4"><h2 class="acymailing_title">';
			if(empty($tag->nolink))
				$result .= '<a href="'.$link.'">';
			$result .= $content->title;
			if(empty($tag->nolink))
				$result .= '</a>';
			$result .= '</h2></td></tr>';
		}

		if(ACYMAILING_J16) $images = json_decode($content->images);
		else $images = '';

		if(!((empty($tag->image) || (empty($images) && ACYMAILING_J16)) && (empty($tag->description) || empty($content->description)))){
			$result .= '<tr><td colspan="4" valign="top" style="text-align:justify;">';
			if(!empty($tag->image) && !empty($images))
			{
				$varFields['{imagehtml}'] = '<img style="float:left;padding-right:5px;" src="images/com_jea/images/'.$tag->id.'/'.$images[0]->name.'"/>';
			}elseif(!empty($tag->image) && !ACYMAILING_J16 && file_exists(JPATH_SITE.DS.'images'.DS.'com_jea'.DS.'images'.DS.$tag->id.DS.'main.jpg')){
				$varFields['{imagehtml}'] = '<img style="float:left;padding-right:5px;" src="images/com_jea/images/'.$tag->id.'/main.jpg"/>';
			}
			$result .= empty($varFields['{imagehtml}']) ? '' : $varFields['{imagehtml}'];
			$result .= $acypluginsHelper->wrapText($content->description, $tag).'</td></tr>';
		}

		$fields = array();

		if(!empty($tag->ref) && !empty($content->ref)) $fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_REF_LABEL' : 'REFERENCE').'</td><td valign="top"> <strong>'.$content->ref.'</strong>';

		if(!empty($tag->availdate)){
			$date = acymailing_getDate(acymailing_getTime($content->availability), JText::_('DATE_FORMAT_LC'));
			if(!empty($date))
				$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_PROPERTY_AVAILABILITY_LABEL' : 'AVAILABILITY DATE').'</td><td valign="top"> <strong>'.$date.'</strong>';
		}

		if(!empty($tag->price) && !empty($content->price)){
			if((ACYMAILING_J16 && $content->transaction_type == 'SELLING') || (!ACYMAILING_J16 && $content->is_renting == 1))
				$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_PRICE_LABEL' : 'BUDGET').'</td><td valign="top"> <strong>'.(ACYMAILING_J16 ? JHtmlUtility::formatPrice((float) $content->price, JText::_('COM_JEA_CONSULT_US')) : (float) $content->price.$this->jeaParams->get( 'currency_symbol' )).'</strong>';
			else
				$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_PRICE_RENT_LABEL' : 'RENTING PRICE').'</td><td valign="top"> <strong>'.(ACYMAILING_J16 ? JHtmlUtility::formatPrice((float) $content->price, JText::_('COM_JEA_CONSULT_US')) : (float) $content->price.$this->jeaParams->get( 'currency_symbol' )).(ACYMAILING_J16 ? JText::_('COM_JEA_PRICE_PER_FREQUENCY_'.$content->rate_frequency) : '').'</strong>';
		}

		if(!empty($tag->charges) && !empty($content->charges))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_CHARGES_LABEL' : 'CHARGES').'</td><td valign="top"> <strong>'.(ACYMAILING_J16 ? JHtmlUtility::formatPrice((float) $content->charges, JText::_('COM_JEA_CONSULT_US')) : (float) $content->charges.$this->jeaParams->get( 'currency_symbol' )).'</strong>';
		if(!empty($tag->fees) && !empty($content->fees))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_FEES_LABEL' : 'FEES').'</td><td valign="top"> <strong>'.(ACYMAILING_J16 ? JHtmlUtility::formatPrice((float) $content->fees, JText::_('COM_JEA_CONSULT_US')) : (float) $content->fees.$this->jeaParams->get( 'currency_symbol' )).'</strong>';
		if(!empty($tag->propcond) && !empty($content->conditiontitle))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_CONDITION_LABEL' : 'GENERAL CONDITION').'</td><td valign="top"> <strong>'.$content->conditiontitle.'</strong>';
		if(!empty($tag->livspace) && !empty($content->living_space))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_LIVING_SPACE_LABEL' : 'LIVING SPACE').'</td><td valign="top"> <strong>'.(ACYMAILING_J16 ? JHtmlUtility::formatSurface((float) $content->living_space) : $content->living_space.$this->jeaParams->get( 'surface_measure' )).'</strong>';
		if(!empty($tag->landspace) && !empty($content->land_space))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_LAND_SPACE_LABEL' : 'LAND SPACE').'</td><td valign="top"> <strong>'.(ACYMAILING_J16 ? JHtmlUtility::formatSurface((float) $content->land_space) : $content->land_space.$this->jeaParams->get( 'surface_measure' )).'</strong>';
		if(!empty($tag->rooms) && !empty($content->rooms))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_NUMBER_OF_ROOMS_LABEL' : 'NUMBER OF ROOMS').'</td><td valign="top"> <strong>'.$content->rooms.'</strong>';
		if(!empty($tag->bedr) && !empty($content->bedrooms))
			$fields[] = JText::_('COM_JEA_FIELD_NUMBER_OF_BEDROOMS_LABEL').'</td><td valign="top"> <strong>'.$content->bedrooms.'</strong>';
		if(!empty($tag->orien) && !empty($content->orientation))
		{
			$orientation = JText::_('COM_JEA_FIELD_ORIENTATION_LABEL').'</td><td valign="top"> <strong>';
			switch($content->orientation)
			{
				case 'N':
					$orientation .= JText::_('COM_JEA_OPTION_NORTH');
						break;
				case 'NW':
					$orientation .= JText::_('COM_JEA_OPTION_NORTH_WEST');
					break;
				case 'NE':
					$orientation .= JText::_('COM_JEA_OPTION_NORTH_EAST');
						break;
				case 'NS':
					$orientation .= JText::_('COM_JEA_OPTION_NORTH_SOUTH');
						break;
				case 'W':
					$orientation .= JText::_('COM_JEA_OPTION_WEST');
						break;
				case 'S':
					$orientation .= JText::_('COM_JEA_OPTION_SOUTH');
						break;
				case 'SW':
					$orientation .= JText::_('COM_JEA_OPTION_SOUTH_WEST');
						break;
				case 'SE':
					$orientation .= JText::_('COM_JEA_OPTION_SOUTH_EAST');
						break;
				case 'E':
					$orientation .= JText::_('COM_JEA_OPTION_EAST');
						break;
				case 'EW':
					$orientation .= JText::_('COM_JEA_OPTION_EAST_WEST');
					break;
			}
			$fields[] = $orientation.'</strong>';
		}
		if(!empty($tag->floor) && !empty($content->floor))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_FLOOR_LABEL' : 'FLOORS').'</td><td valign="top"> <strong>'.$content->floor.'</strong>';
		if(!empty($tag->floorsnb) && !empty($content->floors_number))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_FLOORS_NUMBER_LABEL' : 'NUMBER OF FLOORS').'</td><td valign="top"> <strong>'.$content->floors_number.'</strong>';
		if(!empty($tag->baths) && !empty($content->bathrooms))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_NUMBER_OF_BATHROOMS_LABEL' : 'NUMBER OF BATHROOMS').'</td><td valign="top"> <strong>'.$content->bathrooms.'</strong>';
		if(!empty($tag->toils) && !empty($content->toilets))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_NUMBER_OF_TOILETS_LABEL' : 'NUMBER OF TOILETS').'</td><td valign="top"> <strong>'.$content->toilets.'</strong>';
		if(!empty($tag->heat) && !empty($content->heattitle))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_HEATINGTYPE_LABEL' : 'HEATING TYPE').'</td><td valign="top"> <strong>'.$content->heattitle.'</strong>';
		if(!empty($tag->water) && !empty($content->watertitle))
			$fields[] = JText::_((ACYMAILING_J16) ? 'COM_JEA_FIELD_HOTWATERTYPE_LABEL' : 'HOT WATER TYPE').'</td><td valign="top"> <strong>'.$content->watertitle.'</strong>';

		if(!empty($fields))
		{
			$result .= '<tr><td colspan="4"><br /><strong>'.JText::_(ACYMAILING_J16 ? 'COM_JEA_DETAILS' : 'DETAIL').' :</strong><br /><br /></td></tr>';
			$i = 0;
			foreach($fields as $field)
			{
				if($i%2 == 0)
					$result .= '<tr>';
				$result .= '<td valign="top" style="text-align:center;">'.$field.'</td>';
				$i++;
				if($i%2 == 0)
					$result .= '</tr>';
			}
			if($i%2 == 1)
				$result .= '<td colspan="2"/></tr>';
		}

		if(!empty($tag->address))
		{
			$address = array();
			if(!empty($content->address))
				$address[] = $content->address;
			if(!empty($content->adress))
				$address[] = $content->adress;
			if(!empty($content->deptitle))
				$address[] = JText::_(ACYMAILING_J16 ? 'COM_JEA_FIELD_DEPARTMENT_LABEL' : 'DEPARTMENT').' : '.$content->deptitle;
			if(!empty($content->towntitle))
				$address[] = JText::_(ACYMAILING_J16 ? 'COM_JEA_FIELD_TOWN_LABEL' : 'TOWN').' : '.$content->towntitle;
			if(!empty($content->areatitle))
				$address[] = JText::_(ACYMAILING_J16 ? 'COM_JEA_FIELD_AREA_LABEL' : 'AREA').' : '.$content->areatitle;
			if(!empty($address)){
				$result .= '<tr><td valign="top"><br /><strong>'.JText::_(ACYMAILING_J16 ? 'COM_JEA_FIELD_ADDRESS_LABEL' : 'ADRESS').' :</strong><br /></td><td valign="top" colspan="3"><br />'.implode('<br />', $address).'</td></tr>';
				$varFields['{addressformated}'] = implode('<br />', $address);
			}
		}

		if(!empty($tag->amenities) && ((ACYMAILING_J16 && !empty($content->amenities)) || (!ACYMAILING_J16 && !empty($content->advantages))) && !empty($this->amenities))
		{
			$result .= '<tr><td colspan="4"><br /><strong>'.JText::_(ACYMAILING_J16 ? 'COM_JEA_AMENITIES' : 'AMENITIES').' :</strong><br /><br /></td></tr>';
			$amenities = array();

			if(ACYMAILING_J16)
				$propertyAmen = explode('-', $content->amenities);
			else
				$propertyAmen = explode('-', $content->advantages);

			foreach($propertyAmen as $oneAmenity)
				if(!empty($oneAmenity) && !empty($this->amenities[$oneAmenity]))
					$amenities[] = $this->amenities[$oneAmenity];

			$i = 0;
			foreach($amenities as $amenity)
			{
				if($i%4 == 0)
					$result .= '<tr>';
				$result .= '<td width="25%">'.$amenity.'</td>';
				$i++;
				if($i%4 == 0)
					$result .= '</tr>';
			}
			if($i%4 != 0)
			{
				while($i%4 != 0)
				{
					$result .= '<td width="25%"/>';
					$i++;
				}
				$result .= '</tr>';
			}
		}

		$varFields['{readmore}'] = '<a class="readmore_link" style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.$this->readmore.'</span></a>';
		if(empty($tag->noreadmore)) $result .= '<tr><td colspan="4">'.$varFields['{readmore}'].'</td></tr>';

		$result .= '</table></div><br />';

		// load the custom template if exists
		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php'))
		{
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.$this->name.'.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields),$varFields,$result);
		}

		// always remove JS, there is no JS in newsletters...
		$result = $acypluginsHelper->removeJS($result);

		//resize or remove pictures
		$pictureHelper = acymailing_get('helper.acypict');
		if(isset($tag->pict))
		{
			if($tag->pict == 'resized')
			{
				$pictureHelper->maxHeight = empty($tag->maxheight) ? 150 : $tag->maxheight;
				$pictureHelper->maxWidth = empty($tag->maxwidth) ? 150 : $tag->maxwidth;
				if($pictureHelper->available())
				{
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}else{
				$result = $pictureHelper->removePictures($result);
			}
		}
		return $result;
	}

	function _replaceAuto(&$email)
	{
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags))
		{
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);

			if(!empty($email->altbody))
				$email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);

			foreach($this->tags as $tag => $result)
			{
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$db = JFactory::getDBO();
		$time = time();

		//load the tags
		$tags = $acypluginsHelper->extractTags($email,'auto'.$this->name);
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;

			$query = 'SELECT a.id FROM #__jea_properties AS a ';

			$where = array();

			// filter results created or modified
			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate']))
			{
				if($parameter->filter == 'created')
					$where[] = 'a.created > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
				elseif($parameter->filter == 'modified')
					$where[] = 'a.created > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\' OR a.modified > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
			}

			// Only published content
			$where[] = 'a.published = 1';

			if(!empty($parameter->lang)){
				$where[] = 'a.language = '.$db->Quote($parameter->lang);
			}

			if(!empty($parameter->featured)) $where[] = 'a.featured = 1';
			if(!empty($parameter->nofeatured)) $where[] = 'a.featured = 0';

			if(!empty($parameter->area)) $where[] = 'a.area_id = '.intval($parameter->area);
			if(!empty($parameter->dept)) $where[] = 'a.department_id = '.intval($parameter->dept);
			if(!empty($parameter->town)) $where[] = 'a.town_id = '.intval($parameter->town);
			if(!empty($parameter->agentid)) $where[] = 'a.created_by = '.intval($parameter->agentid);

			// Apply filters
			if(!empty($where)){
				$query .= ' WHERE ('.implode(') AND (',$where).')';
			}

			// Ordering
			if(!empty($parameter->order)){
				if($parameter->order == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',',$parameter->order);
					$query .= ' ORDER BY a.'.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			// If there is no limit, then we add one
			if(!empty($parameter->max)) $query .= ' LIMIT '.intval($parameter->max);
			else $query .= ' LIMIT 20'; // limit, because we do not want to display one bilion contents in the newsletter...

			// load content IDs
			$db->setQuery($query);
			$allArticles = acymailing_loadResultArray($db);

			// Check the number of results
			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We will not generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough '.$this->name.' content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min;
			}

			$stringTag = '';
			if(!empty($allArticles)){
				// If the user created its own template...
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'auto'.$this->name.'.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the tags one after the other in a table as they are already sorted (using |cols parameter)
					$arrayElements = array();
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = $this->name.':'.$oneArticleId;
						if(!empty($parameter->nolink)) $args[] = 'nolink';
						if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->display)) $args[] = 'display:'.$parameter->display;
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|',$args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements,$parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}
}//endclass
?>